require "logging"

# rubocop:disable Style/ClassVars
# rubocop:disable Style/GuardClause
module Blackfire
  module Logger
    @@global_logger = Logging.logger["Blackfire Ruby Probe"]

    class << self
      def initialize
        @@global_logger.level = Config.log_level

        @@global_logger.add_appenders Logging.appenders.stdout if Config.log_to_stdout?
        @@global_logger.add_appenders Logging.appenders.stderr if Config.log_to_stderr?

        if Config.log_to_file?
          begin
            @@global_logger.add_appenders Logging.appenders.file(Config.log_file)
          rescue StandardError
            nil
          end
        end
      end

      def build
        @@global_logger
      end
    end
  end
end
# rubocop:enable Style/ClassVars
# rubocop:enable Style/GuardClause
