module Blackfire
  MULTIPLIER_FOR_TIME = 1_000_000
  MULTIPLIER_FOR_MEMORY = 1

  module PrinterHelper
    # rubocop:disable Metrics/PerceivedComplexity
    def build_target_name(call_tree, query_order)
      return call_tree.target.full_name.to_s if call_tree.parent.nil?

      original_method = call_tree.target.full_name.split("#")[1]
      full_name = call_tree.target.full_name

      origin_method = ""
      dest_method = ""
      if QueryTrace.exec_methods.nil? || !FnArgs.should_report_queries?
        dest_method = escape_method_name(full_name.to_s)
        origin_method = escape_method_name(call_tree.parent.target.full_name)
      else
        dest_method = if QueryTrace.exec_methods.include? original_method
                        sql = QueryTrace.report_sql(original_method, query_order)
                        sql.nil? ? escape_method_name(full_name).to_s : "#{escape_method_name(full_name)}?1=#{sql}"
                      else
                        escape_method_name(full_name.to_s)
                      end

        original_method = call_tree.parent.target.full_name.split("#")[1]
        full_name = call_tree.parent.target.full_name
        origin_method = if QueryTrace.exec_methods.include? original_method
                          sql = QueryTrace.report_sql(original_method, query_order)
                          sql.nil? ? escape_method_name(full_name).to_s : "#{escape_method_name(full_name)}?1=#{sql}"
                        else
                          escape_method_name(full_name.to_s)
                        end
      end

      "#{origin_method}==>#{dest_method}"
    end
    # rubocop:enable Metrics/PerceivedComplexity

    def escape_method_name(method_name)
      method_name.gsub! "?", "%3F"
      method_name.gsub("!", "%21")
    end
  end
end
