# frozen_string_literal: true

module Rack
  class BlackfireRack
    class Mysql2::Result
      alias each_without_profiling each
      def each(*args, &blk)
        return each_without_profiling(*args, &blk) unless defined?(@blackfire_sql_id)

        each_without_profiling(*args, &blk)
      end
    end

    class Mysql2::Client
      alias query_without_profiling query
      def query(*args, &blk)
        return query_without_profiling(*args, &blk) unless SqlPatches.should_measure?

        Blackfire::QueryTrace.record_sql(args[0], nil)
        result, record = query_without_profiling(*args, &blk)
        result&.instance_variable_set("@blackfire_sql_id", record)
        result
      end
    end
  end
end
